package com.ruoyi.system.domain;

import java.math.BigDecimal;
import java.util.List;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 优惠券对象 coupons
 *
 * @author ruoyi
 * @date 2025-05-16
 */
public class Coupons extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** $column.columnComment */
    private Long id;

    /** 名称 */
    @Excel(name = "名称")
    private String title;

    /** 面值 */
    @Excel(name = "面值")
    private BigDecimal price;

    /** 最低消费 */
    @Excel(name = "最低消费")
    private BigDecimal minPrice;


    private BigDecimal priceMin;
    private BigDecimal priceMax;
    private BigDecimal minPriceMin;
    private BigDecimal minPriceMax;
    private Long countMin;
    private Long countMax;

    /** 开始领取时间 */
    @Excel(name = "开始领取时间")
    private Long startTime;

    /** 截止领取时间 */
    @Excel(name = "截止领取时间")
    private Long endTime;

    /** 数量 */
    @Excel(name = "数量")
    private Long count;

    /** 是否无限领取 */
    @Excel(name = "是否无限领取")
    private Long isPermanent;

    /** 1 正常 0 关闭 */
    @Excel(name = "1 正常 0 关闭")
    private Long status;


    /** 领取记录关闭 */
    @Excel(name = "领取记录")
    private int lqjv;

    /** 有效期 */
    @Excel(name = "有效期")
    private Long couponTime;

    /** 指定商品 */
    @Excel(name = "指定商品")
    private Long productId;

    /** 1：新人券 2：手动领取 3：系统赠送 */
    @Excel(name = "1：新人券 2：手动领取 3：系统赠送")
    private Long type;

    /** 1:通用券 2：品类券 3：指定商品 */
    @Excel(name = "1:通用券 2：品类券 3：指定商品")
    private Long receiveType;

    /** 排序 */
    @Excel(name = "排序")
    private String sort;

    /** 指定分类 */
    @Excel(name = "指定分类")
    private Long cateId;

    /** 系统赠送用户 */
    @Excel(name = "系统赠送用户")
    private String userIds;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Date createdAt;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Date updatedAt;

    /** $column.columnComment */
    private Date deletedAt;

    /** 优惠券领取记录信息 */
    private List<CouponUser> couponUserList;

    public void setId(Long id)
    {
        this.id = id;
    }

    public Long getId()
    {
        return id;
    }

    public void setTitle(String title)
    {
        this.title = title;
    }

    public String getTitle()
    {
        return title;
    }

    public void setPrice(BigDecimal price)
    {
        this.price = price;
    }

    public BigDecimal getPrice()
    {
        return price;
    }

    public void setMinPrice(BigDecimal minPrice)
    {
        this.minPrice = minPrice;
    }

    public BigDecimal getMinPrice()
    {
        return minPrice;
    }

    public void setStartTime(Long startTime)
    {
        this.startTime = startTime;
    }

    public Long getStartTime()
    {
        return startTime;
    }

    public void setEndTime(Long endTime)
    {
        this.endTime = endTime;
    }

    public Long getEndTime()
    {
        return endTime;
    }

    public void setCount(Long count)
    {
        this.count = count;
    }

    public Long getCount()
    {
        return count;
    }

    public void setIsPermanent(Long isPermanent)
    {
        this.isPermanent = isPermanent;
    }

    public Long getIsPermanent()
    {
        return isPermanent;
    }

    public void setStatus(Long status)
    {
        this.status = status;
    }

    public Long getStatus()
    {
        return status;
    }

    public void setCouponTime(Long couponTime)
    {
        this.couponTime = couponTime;
    }

    public Long getCouponTime()
    {
        return couponTime;
    }

    public void setProductId(Long productId)
    {
        this.productId = productId;
    }

    public Long getProductId()
    {
        return productId;
    }

    public void setType(Long type)
    {
        this.type = type;
    }

    public Long getType()
    {
        return type;
    }

    public void setReceiveType(Long receiveType)
    {
        this.receiveType = receiveType;
    }

    public Long getReceiveType()
    {
        return receiveType;
    }

    public void setSort(String sort)
    {
        this.sort = sort;
    }

    public String getSort()
    {
        return sort;
    }

    public void setCateId(Long cateId)
    {
        this.cateId = cateId;
    }

    public Long getCateId()
    {
        return cateId;
    }

    public void setUserIds(String userIds)
    {
        this.userIds = userIds;
    }

    public String getUserIds()
    {
        return userIds;
    }

    public void setCreatedAt(Date createdAt)
    {
        this.createdAt = createdAt;
    }

    public Date getCreatedAt()
    {
        return createdAt;
    }

    public void setUpdatedAt(Date updatedAt)
    {
        this.updatedAt = updatedAt;
    }

    public Date getUpdatedAt()
    {
        return updatedAt;
    }

    public void setDeletedAt(Date deletedAt)
    {
        this.deletedAt = deletedAt;
    }

    public Date getDeletedAt()
    {
        return deletedAt;
    }

    public List<CouponUser> getCouponUserList()
    {
        return couponUserList;
    }

    public void setCouponUserList(List<CouponUser> couponUserList)
    {
        this.couponUserList = couponUserList;
    }

    public int getLqjv() {
        return lqjv;
    }

    public void setLqjv(int lqjv) {
        this.lqjv = lqjv;
    }

    public Long getCountMax() {
        return countMax;
    }

    public void setCountMax(Long countMax) {
        this.countMax = countMax;
    }

    public Long getCountMin() {
        return countMin;
    }

    public void setCountMin(Long countMin) {
        this.countMin = countMin;
    }

    public BigDecimal getMinPriceMax() {
        return minPriceMax;
    }

    public void setMinPriceMax(BigDecimal minPriceMax) {
        this.minPriceMax = minPriceMax;
    }

    public BigDecimal getMinPriceMin() {
        return minPriceMin;
    }

    public void setMinPriceMin(BigDecimal minPriceMin) {
        this.minPriceMin = minPriceMin;
    }

    public BigDecimal getPriceMax() {
        return priceMax;
    }

    public void setPriceMax(BigDecimal priceMax) {
        this.priceMax = priceMax;
    }

    public BigDecimal getPriceMin() {
        return priceMin;
    }

    public void setPriceMin(BigDecimal priceMin) {
        this.priceMin = priceMin;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
                .append("id", getId())
                .append("title", getTitle())
                .append("price", getPrice())
                .append("minPrice", getMinPrice())
                .append("startTime", getStartTime())
                .append("endTime", getEndTime())
                .append("count", getCount())
                .append("isPermanent", getIsPermanent())
                .append("status", getStatus())
                .append("couponTime", getCouponTime())
                .append("productId", getProductId())
                .append("type", getType())
                .append("receiveType", getReceiveType())
                .append("sort", getSort())
                .append("cateId", getCateId())
                .append("userIds", getUserIds())
                .append("createdAt", getCreatedAt())
                .append("updatedAt", getUpdatedAt())
                .append("deletedAt", getDeletedAt())
                .append("couponUserList", getCouponUserList())
                .toString();
    }
}
